<template>
	<a-drawer
		:title="formData.id ? '编辑出入库异常' : '增加出入库异常'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="企业客户：" name="depotId" v-if="!formData.depotId">
				<a-select v-model:value="formData.depotId" placeholder="请选择企业客户" :options="depotIdOptions"/>
			</a-form-item>
			<a-form-item label="出入库：" name="depotBizType">
				<a-radio-group v-model:value="formData.depotBizType" :options="depotBizTypeOptions"/>
			</a-form-item>
			<a-form-item label="车牌：" name="licensePlate">
				<a-input v-model:value="formData.licensePlate" placeholder="请输入车牌" allow-clear/>
			</a-form-item>
			<a-form-item label="异常分类：" name="alarmType">
				<a-radio-group v-model:value="formData.alarmType" :options="[{label:'异常',value:'异常'},{label:'报警',value:'报警'}]"/>
			</a-form-item>
			<a-form-item label="异常信息：" name="alarmMsg">
				<a-input v-model:value="formData.alarmMsg" placeholder="请输入异常信息" allow-clear/>
			</a-form-item>
			<a-form-item label="异常原因：" name="alarmCause">
				<a-input v-model:value="formData.alarmCause" placeholder="请输入异常原因" allow-clear/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotWorkAlarmForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import depotWorkAlarmApi from '@/api/biz/depotWorkAlarmApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)
const depotIdOptions = ref([])
const depotBizTypeOptions = ref([])

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	} else {
		dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
			depotIdOptions.value = data
		})
	}
	depotBizTypeOptions.value = tool.dictList('出入库')
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	depotId: [required('请输入项目编码')],
	depotBizType: [required('请输入出入库:入库/出库')],
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			depotWorkAlarmApi
				.depotWorkAlarmSubmitForm(formDataParam, !formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
